/*  :ts=8 bk=0
 *
 * marketroid.h:	Data structure definitions for the program.
 *
 * Leo L. Schwab			8709.30		(415) 456-3960
 */
#ifndef GRAPHICS_GFX_H
#include <graphics/gfx.h>
#endif

/*
 * The basic object description structures.  Yes, I could have used the
 * animation/GEL software, but the code to utilize it would have been
 * non-trivial.  [Oh.  And this *IS* trivial?]  Besides, the GEL routines
 * would have made it impossible to perform certain special effects I need,
 * whereas I can perform the necessary rape using BltBitMap() or ClipBlit().
 */
struct object {
	struct BitMap	*bitmap;	/*  Pointer to bitmap with image  */
	WORD		width, height;	/*  Size of figure within bitmap  */
	WORD		nframes;	/*  # of frames for this figure   */
	UBYTE		*animseq;	/*  Animation sequencing array	  */
	WORD		upx, upy,	/*  Offsets into the bitmap for   */
			downx, downy,	/*   the frames of the figure	  */
			leftx, lefty,   /*   when it is walking in the	  */
			rightx, righty;	/*   specified direction.	  */
	WORD		incr;		/*  Suggested movement increment  */
};

struct obcontrol {
	struct object	*ob;		/*  Pointer to controlled object  */
	WORD		x, y;		/*  On-screen position		  */
	WORD		dx, dy;		/*  Current X and Y increments	  */
	WORD		frame;		/*  Current frame number	  */
};
