

RLS(1)                  AmigaDos 1.2                  RLS(1)

NAME 
   rls - recursively list a directory's contents 


SYNOPSIS 
   rls [-adqs] directoryname ... 


REVISION 
   0.010, compiled with Manx 3.4b C compiler. 


DESCRIPTION 
   For each name passed as an argument, rls will list each
   file name in that directory and for each sub-directory it
   will recursively list any files. Directory names can also
   be listed optionally. The file (and optional directory)
   names are listed with the appropriate path, one name per
   line. 

   rls accepts directory or device names as arguments. It
   may also be passed names ASSIGN'ed through the AmigaDOS
   Assign command. 

   The user may abort the program by entering control-c from
   the keyboard. All locks and memory are returned to the
   system. 


   OPTIONS 
      If the first command-line parameter starts with a '-'
      (minus) character, it is interpreted as a list of
      options. Options may only appear in the first
      parameter; this enables directory names that begin
      with the '-' character to be listed in a coherent
      fashion. Current options are: 

      -d List directory names separately; normally only
         paths to file names are listed. 

      -s Don't substitute volume names for device names in
         the listing. 

      -q Enclose any pathnames that include spaces with
         quotes. 

      -a Enclose all pathnames with quotes, reguardless of
         spaces. 


ERRORS 
   Should any errors occur during the scan, an appropriate
   error message is printed. (This message will be on the
   console and will not get re-directed to wherever the
   standard output is going.) An error will cause the
   program to abort, returning an error code of 10. 

   A maximum depth of 30 sub-directories is permitted. If

(11/14/87)     Copyright 1987, by Don Kindred         Page 1




RLS(1)                  AmigaDos 1.2                  RLS(1)

   the maximum depth is exceeded, the program aborts. 


EXAMPLES 
   1>rls >ram:list df0: 
      (If no errors occur, the ouput will go to the file
      ram:list. If an error does occur, a message will
      appear on the console. The actual name of the disk in
      drive df0: will be substituted for "df0:" in the
      listing.) 

   1>rls -s df0: 
      (Will list all the files on drive df0:. "df0:" will
      appear in the listing.) 

   1>rls this_dir 
      (Will list all the files in directory "this_dir".) 

   1>rls - -this_dir 
      (Will list all the files in directory "-this_dir".) 

   1>rls -this_dir 
      (Will produce some error message, because "-this_dir"
      is interpreted as a string of options.) 

   1>rls -qd df0: 
      (Will list all file and directory directory names on
      df0:. Further, each name that contains a space will be
      quoted.) 

   1>rls -a df0: 
      (Will list all file names on df0:. Each name will
      appear inside quotes.) 


AUTHOR 
   Don Kindred 


BUGS 
   No major bugs have been reported. 

   Better error messages could be implemented for various
   error conditions. 

   Currently, error messages only go to the console. If the
   standard output has been redirected to a file, error
   messages will not appear in the file. 

   If you find any bugs or would like to hire a good C
   programmer, feel free to drop me a line: 

      Don Kindred
      5430 S. Keystone Ave.
      Indpls., IN  46227




(11/14/87)     Copyright 1987, by Don Kindred         Page 2


