
/*
 * SHELL.H
 *
 * (c)1986-1988 Matthew Dillon     18 August 1988
 *
 *
 * SHELL include file.. contains shell parameters and extern's
 *
 *
 */

#include <local/typedefs.h>

/*#define FIBF_ARCHIVE	  (1<<4)*/

#define MAXAV		128	    /* Max. # arguments 	    */
#define MAXSRC		5	    /* Max. # of source file levels */
#define MAXIF		10	    /* Max. # of if levels	    */
#define MAXALIAS	20	    /* Max. # of alias levels	    */


#define LEVEL_SET    0		    /* which variable list to use   */
#define LEVEL_ALIAS  1
#define LEVEL_LABEL  2

#define V_PROMPT     "_prompt"      /* your prompt (ascii command)   */
#define V_HIST	     "_history"     /* set history depth (value)     */
#define V_HISTNUM    "_histnum"     /* set history numbering var     */
#define V_DEBUG      "_debug"       /* set debug mode                */
#define V_VERBOSE    "_verbose"     /* set verbose for source files  */
#define V_STAT	     "_maxerr"      /* worst return value to date    */
#define V_LASTERR    "_lasterr"     /* return value from last comm.  */
#define V_CWD	     "_cwd"         /* current directory             */
#define V_EXCEPT     "_except"      /* "nnn;command"                 */
#define V_PASSED     "_passed"      /* passed arguments to source fle*/
#define V_PATH	     "_path"        /* path prefix,prefix,prefix..   */
#define V_IGNOREEOF  "_ignoreeof"   /* ignore EOF for interactive tty*/
#define V_COPYSILENT "_copysilent"  /* silent copy                   */
#define V_COPYDATE   "_copydate"    /* transport datestamp           */


	    /* EXECOM.C defines */

#define FL_DOLLAR    0x01  /* One of the following */
#define FL_BANG      0x02
#define FL_PERCENT   0x04
#define FL_QUOTE     0x08
#define FL_IDOLLAR   0x10  /* Any or all of the following may be set */
#define FL_EOC	     0x20
#define FL_EOL	     0x40
#define FL_OVERIDE   0x80
#define FL_WILD      0x100
#define FL_MASK      (FL_DOLLAR|FL_BANG|FL_PERCENT|FL_QUOTE)

#define VERSION   "V2.10 (C)Copyright 1986-88 Matthew Dillon, All Rights Reserved, 18 August 1988"

#ifndef NULL
#define NULL 0L
#endif

#define CHECKBREAK()    docheckbreak()

struct HIST {
   struct HIST *next, *prev;	 /* doubly linked list */
   char *line;			 /* line in history    */
};

struct PERROR {
   short errnum;		 /* Format of global error lookup */
   char *errstr;
};

struct DPTR {			 /* Format of directory fetch pointer */
   struct FileLock *lock;	 /* lock on directory	*/
   struct FileInfoBlock *fib;	 /* mod'd fib for entry */
};

extern struct HIST *H_head, *H_tail;
extern struct PERROR Perror[];
extern struct DPTR *dopen();
extern char *set_var(), *get_var(), *next_word();
extern char *get_history(), *compile_av();
extern char *strcpy(), *strcat(), *gets(), *Ogets();
extern char **expand();
extern long FindIt();


extern char *av[];
extern char *Current;
extern short H_len, H_tail_base, H_stack;
extern short E_stack;
extern short Src_stack, If_stack;
extern short ac;
extern short SDebug, Verbose, SDisable, Quit;
extern long Lastresult;
extern short Exec_abortline, Exec_ignoreresult;
extern short S_histlen, S_ignoreeof;
extern long Uniq;
extern long Cin, Cout, Cerr, Cout_append;
extern char *Cin_name, *Cout_name;
extern char  Cin_type,	Cout_type;  /* these variables are in transition */
extern char *Pipe1, *Pipe2;
extern long DResBase;

extern int  Src_base[MAXSRC];
extern long Src_pos[MAXSRC];
extern char If_base[MAXIF];


